###############################################################################
# Display.pl                                                                  #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$displayplver = "1 Gold - SP 1.1";

sub Display {
	my($msf,$mfn,$attachment,$showattach);
	my $viewnum = $INFO{'num'};
	if( $viewnum =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	$maxmessagedisplay ||= 10;
	my($buffer,$views,$lastposter,$moderators,$counter,$counterwords,$pageindex,$msubthread,$mnum,$mstate,$mdate,$msub,$mname,$memail,$mreplies,$musername,$micon,$noposting,$threadclass,$notify,$max,$start,$bgcolornum,$windowbg,$mattach,$mip,$mlm,$mlmb,$lastmodified,$postinfo,$star,$sendm,$topicdate);
	my(@userprofile,@messages,@bgcolors);

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$curcat = <FILE>;
	fclose(FILE);
	#$curcat = $cat;
	fopen(FILE, "$boardsdir/$curcat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);

	# Load the membergroups list.
	fopen(FILE, "$vardir/membergroups.txt") || &fatal_error("100 $txt{'106'}: $txt{'23'} membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);

	# Mark current thread as read.
	## LAST READ MOD ##
 	($mnum,$tmpa,$tmpa,$tmpa,$mdate,$mreplies) = split(/\|/,$yyThreadLine);
 	$mreplies++;
 	&dumplog($mnum,$mdate,$mreplies);
	## /LAST READ MOD ##

	# Add 1 to the number of views of this thread.
	if(fopen(FILE, "$datadir/$viewnum.data")) {
		$tmpa = <FILE>;
		fclose(FILE);
	}
	elsif( -e "$datadir/$viewnum.data" ) { &fatal_error("102 $txt{'106'}: $txt{'23'} $viewnum.data"); }
	else { $tmpa = '0'; }
	($tmpa, $tmpb) = split( /\|/, $tmpa );
	$tmpa++;
	fopen(FILE, "+>$datadir/$viewnum.data") || &fatal_error("103 $txt{'106'}: $txt{'23'} $viewnum.data");
	print FILE qq~$tmpa|$tmpb~;
	fclose(FILE);
	$views = $tmpa - 1;

	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );
	$noposting = $viewnum eq $mnum && $mstate == 1 ? 1 : 0;

	# Get the class of this thread, based on lock status and number of replies.
	$replybutton = qq~<a href="$cgi;action=post;num=$viewnum;title=$txt{'116'};start=$start">$img{'reply'}</a>~;
	$threadclass = 'thread';
	if( $mstate == 1 ) {
		$threadclass = 'locked';
		$replybutton = "";
	}
	elsif( $mreplies > 24 ) { $threadclass = 'veryhotthread'; }
	elsif( $mreplies > 14 ) { $threadclass = 'hotthread'; }
	elsif( $mstate == 0 ) { $threadclass = 'thread'; }
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	fclose(FILE);
	foreach $curnum (@stickys) {
		if ($mnum == $curnum) {
			if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
			else { $threadclass = 'sticky'; }
		}
	}

	&LoadCensorList;	# Load Censor List

	# Build a list of this board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	if($enable_notification) {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$cgi;action=notify;thread=$viewnum;start=$startnum">$img{'notify'}</a>~;
	}
	&jumpto;	# create the jumpto list

	# Build the page links list.
	$postdisplaynum = 3;	# max number of pages to display
	$max = $mreplies + 1;
	$start = $INFO{'start'} || 0;
	$start = $start > $mreplies ? $mreplies : $start;
	$start = ( int( $start / $maxmessagedisplay ) ) * $maxmessagedisplay;
	$tmpa = 1;
	$tmpx = int( $max / $maxmessagedisplay );
	if ($start >= (($postdisplaynum-1) * $maxmessagedisplay)) { $startpage = $start - (($postdisplaynum-1) * $maxmessagedisplay); $tmpa = int( $startpage / $maxmessagedisplay ) + 1; }
	if ($max >= $start + ($postdisplaynum * $maxmessagedisplay)) { $endpage = $start + ($postdisplaynum * $maxmessagedisplay); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=display;num=$viewnum;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxmessagedisplay) { $pageindex = qq~<a href="$cgi;action=display;num=$viewnum;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=display;num=$viewnum;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $maxmessagedisplay;
	$outerpn = int($tmpx / $maxmessagedisplay) + 0;
	$lastpn = int($mreplies / $maxmessagedisplay) + 1;
	$lastptn = ($lastpn - 1) * $maxmessagedisplay;
	if ($endpage < $max - ($maxmessagedisplay) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=display;num=$viewnum;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$msubthread =~ s~\Q$tmpa\E~$tmpb~gi;
	}
	if ($boardlinks == 1) {$yymain .= "$blink";}
	$curthreadurl = $curposlinks ? qq~<a href="$cgi;action=display;num=$viewnum" class="nav">$msubthread</a>~ : $msubthread;
# Begin addon for boardlinksSP1
	$blink = '';
	$i=0;
	$ii=0;
	while($LinkBoard[$i]) {
		if ($LinkBoard[$i] eq $currentboard){
			if ($ii == 0){
				$blink .= qq~<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
				$ii=1;
			} else {
				$blink .= qq~$blinkstxt{'13'}<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
			}
		}
		$i++;
	}
	if ($blink ne ''){
		$blink = qq~<table width="100%" cellpadding=3 cellspacing=0><TD align="center" class="catbg" bgcolor="$color{'titletext'}"><font size=2>$blinkstxt{'12'}$boardname</font><BR>$blink</TD></table><BR><BR>~;
	}
	if ($boardlinks != 1) {$yymain .= "$blink";}
# End addon for boardlinksSP1

	# Create next/prev links
	$default_sort = "";
	if (-e "$boardsdir/$currentboard.opt" ) { require "$boardsdir/$currentboard.opt"; }
	fopen(LISTS, "$boardsdir/$INFO{'board'}.txt");
	@boardtopics = <LISTS>;
	$threadcount = $#boardtopics + 1;
	fclose(LISTS);

	# Sort list
	if ($default_sort ne "") {
		@tmplist = @boardtopics;
		$date2 = $date;
		for($i=0;$i<$threadcount;$i++) {
			($mnum, $msub, $mname, $dummy, $mdate, $mreplies, $dummy) = split( /\|/, $boardtopics[$i], 7 );
			if ($default_sort eq "subject") { $tmplist[$i] = $msub."|".$boardtopics[$i];	}
			elsif ($default_sort eq "created") {
				fopen(FILE, "$datadir/$mnum.txt");
				$tmpa = <FILE>;
				fclose(FILE);
				($dummy, $dummy, $dummy, $date1, $dummy) = split(/\|/, $tmpa, 5);
				&calcdifference;
				$tmplist[$i] = $result."|".$boardtopics[$i];
			}
			elsif ($default_sort eq "author") { $tmplist[$i] = $mname."|".$boardtopics[$i]; }
			elsif ($default_sort eq "last") {
				$date1 = $mdate;
				&calcdifference;
				$tmplist[$i] = $result."|".$boardtopics[$i];
			}
			elsif ($default_sort eq "replies") { $tmplist[$i] = $mreplies."|".$boardtopics[$i]; }
			elsif ($default_sort eq "views") { 
				if( -e "$datadir/$mnum.data" ) {
					fopen(FILE, "$datadir/$mnum.data");
					$tmpa = <FILE>;
					fclose(FILE);
					($views, $dummy) = split(/\|/, $tmpa, 2);
					$views = $views ? $views - 1 : 0;
				} else { $views = "0"; }
				$tmplist[$i] = $views."|".$boardtopics[$i]; 
			}
			elsif ($default_sort eq "rating") { 
				if( -e "$datadir/$mnum.data" ) {
					fopen(FILE, "$datadir/$mnum.data");
					$tmpa = <FILE>;
					fclose(FILE);
					($dummy, $dummy, $rate, $dummy) = split( /\|/, $tmpa, 4 );
					if ($rate eq "") { $rate = "0"; }
				} else { $rate = "0"; }
				$tmplist[$i] = $rate."|".$boardtopics[$i]; 
			}
		}
		if ($default_sort eq "subject" || $default_sort eq "author") { @sortlist = sort{uc($a) cmp uc($b)} (@tmplist); }
		elsif ($default_sort eq "created" || $default_sort eq "last") { @sortlist = sort{$a<=>$b} (@tmplist); }
		else { @sortlist = sort{$b<=>$a} (@tmplist); }
		for($i=0;$i<$threadcount;$i++) {
			($dummy, $tmplist[$i]) = split(/\|/, $sortlist[$i], 2);
			$boardtopics[$i] = $tmplist[$i]."\n";
		}
		chomp(@boardtopics);
	}

	my $found;
	my $name = $INFO{'num'};
	my $bcount = 0;
	$CurrentPosition = -1;
	foreach $ThreadNum (@boardtopics) {
		++$CurrentPosition;
		if ($ThreadNum =~ m/\A$name/o) { $found = 1; last; }
	}

	$previous = $boardtopics[$CurrentPosition-1];
	$next = $boardtopics[$CurrentPosition+1];
	@prevthread = split(/\|/, $previous);
	$goprevious = $prevthread[0];
	@nextthread = split(/\|/, $next);
	$gonext = $nextthread[0];
	@getlastthread = @boardtopics;
	$lastthread = pop(@getlastthread);
	@lasttopic = split(/\|/, $lastthread);
	$endthread2 = $lasttopic[0];
	if($found) {
		$prevtopic = "$cgi;action=display;num=$goprevious";
		$nexttopic = "$cgi;action=display;num=$gonext";
		$endthread = "$cgi;action=display;num=$endthread2";
	}
	if( $endthread eq $prevtopic && $gonext eq "") { $nav = qq~&#171; $txt{'766'} | $txt{'766'} &#187;~; }
	if($endthread eq $prevtopic && $gonext ne "") { $nav = qq~&#171; $txt{'766'} | <a href="$nexttopic">$txt{'767'}</a> &#187;~; }
	if ( $endthread ne $prevtopic && $gonext eq "") { $nav = qq~&#171; <a href="$prevtopic">$txt{'768'}</a> | $txt{'766'} &#187;~; }
	if ($endthread ne $prevtopic && $gonext ne "") { $nav = qq~&#171; <a href="$prevtopic">$txt{'768'}</a> | <a href="$nexttopic">$txt{'767'}</a> &#187;~; 	}
	$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td valign=bottom colspan="2"><font size="2" class="nav"><B>
    <img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <img src="$imagesdir/tline.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl#$curcat" class="nav">$cat</a><br>
    <img src="$imagesdir/tline2.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$cgi" class="nav">$boardname</a> </b><font size="1">$showmods</font><b><br>
    <img SRC="$imagesdir/tline3.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    $curthreadurl</b></font></td>
    <td valign="bottom" align="right"><font size="1">$nav</font></td>
  </tr>
</table>
<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size="2"><b>$txt{'139'}:</b> $pageindex</font></td>
            <td class="catbg" bgcolor="$color{'catbg'}" align="right"><font size="2">
            $replybutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;

	# Look for a poll file for this thread.
	
	if (-e "$datadir/$viewnum.poll") { $pollthread = 1; }
	
	if ($pollthread) {
	fopen (FILE, "$datadir/$viewnum.poll");
	@polldata = <FILE>;
	fclose (FILE);
	
	$pollquestion = $polldata[0];
	@polldata2 = @polldata;
	($blah1, $blah2) = split(/\|/, $polldata2[0]);
	if ($blah2) { 
	$num = 0; 
	fopen (FILE, "$datadir/$viewnum.txt"); 
	@postdata = <FILE>;
	fclose (FILE);
	($msubject, $blah) = split(/\|/, $postdata[0]);
	$pollquestion = $msubject; 
	} 
	else {$num = 1; }
	
	$line = 0;
	my @options;
	my @votes;
	foreach $pointer (@polldata) {
		($vote, $option) = split(/\|/, $polldata[$num]);
		$options[$line] = $option;
		$votes[$line] = $vote;
		$line++;
		$num++;
	}
	@options_uncensored = @options;
if ($blah2) { 
$options[$line++] = "";
}
$search = -1;
my $found;
fopen (FILE, "$memberdir/$username.dat");
@usersdata = <FILE>;
fclose (FILE);
chop $usersdata[2];
chop $usersdata[7];
$usersemail = $usersdata[2];
$userstatus = $usersdata[7];

fopen(FILE, "$datadir/$viewnum.polled");
while( $LineNum = <FILE> ) {
	($useremail, $usersname) = split(/\|/, $LineNum);
     ++$search;
     if ( $usersname =~ /\b$username\b/ or $useremail =~ /\b$usersemail\b/) { $found = 1; last; }
}
close(FILE);
	
	if ($found) { $userhasvoted = 1; }
	$viewresults = $INFO{'viewresults'};
	fopen (FILE, "$datadir/$viewnum.txt");
	@threaddata = <FILE>;
	fclose (FILE);
	($subject, $dname, $semail, $data, $susername, $junk) = split(/\|/, $threaddata[0]);
	if (-e "$datadir/$viewnum.polll") { $pollislocked = 1; }
	if ($username ne "Guest" && $username eq $susername && $pollislocked ne 1) { $lockpoll = qq~<a href="$cgi;action=lockpoll;num=$viewnum">$polltxt{'20'}</a>~; }
	if ($username ne "Guest" && $username eq $susername && $pollislocked eq 1) { $lockpoll = qq~<a href="$cgi;action=unlockpoll;num=$viewnum">$polltxt{'21'}</a>~; }
	if ($userstatus eq "Administrator" && $pollislocked ne 1 or $userstatus eq "Global Moderator" && $pollislocked ne 1 or exists $moderators{$username} && $pollislocked ne 1) { $lockpoll = qq~<a href="$cgi;action=lockpoll;num=$viewnum">$polltxt{'20'}</a>~; }
	if ($userstatus eq "Administrator" && $pollislocked eq 1 or $userstatus eq "Global Moderator" && $pollislocked eq 1 or exists $moderators{$username} && $pollislocked eq 1) { $lockpoll = qq~<a href="$cgi;action=unlockpoll;num=$viewnum">$polltxt{'21'}</a>~; }
	
	if ($pollislocked eq 1) { $endedtext = $polltxt{'22'}; }
	if ($userhasvoted and $username ne "Guest" or $viewresults eq 'yes' or $pollislocked eq 1) {
		# Censor the question.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$pollquestion =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		
		$yymain.= qq~<table border="0" width="100%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
		<tr>
		<td height="22" valign="middle" class="titlebg" color="$color{'titlebg'}">
		<font size=2 class="text1" color="$color{'titletext'}">&nbsp;$img{'pollicon'}&nbsp;$polltxt{'15'}</font>
		</td>
		</tr>
		<tr>
		<td valign="top">
		<table border="0" width="100%" cellspacing="0" cellpadding="5" bgcolor="$color{'windowbg'}" class="windowbg">
  <tr valign="top">
    <td width="65"><b>$polltxt{'16'}:</b></td>
    <td>$pollquestion &nbsp;&nbsp;&nbsp;$endedtext<br><br>
    </td>
  </tr>
  <tr> 
    <td>&nbsp;</td>
        <td>
    <table width="90%" border="0" cellspacing="0" cellpadding="0">~;
    $nums = 0;
    
    my $Key; 
	my $Total; 
	foreach $Key (@votes) { 
	$Total += $Key; 
	} 

  $totalvotes = $Total;
  pop (@options);
    foreach (@options) {
        	# Censor the options.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$options[$nums] =~ s~\Q$tmpa\E~$tmpb~gi;
		}
    	$yymain .= qq~
  <tr valign="top"> 
	<td><b>$options[$nums]&nbsp;&nbsp;</b></td>
    <td>~;
    unless ($votes[$nums] eq 0) {
    
$votepercent = ( $votes[$nums] / $totalvotes );				
$pollbarpercent = ($votepercent * 100);
$votepercent = ($votepercent * 100);

# Now lets calculate how many devisions by the total number of votes are needed to make the bar graphs stay nicely sized in the browser window:

if ($totalvotes <= "10000" && $totalvotes => "5001") {
$pollbar = ($pollbarpercent / 1000);
}
if ($totalvotes <= "5000" && $totalvotes => "1001") {
$pollbar = ($pollbarpercent / 100);
}
if ($totalvotes <= "1000" && $totalvotes => "501") {
$pollbar = ($pollbarpercent / 50);
}
if ($totalvotes <= "500" && $totalvotes => "101") {
$pollbar = ($pollbarpercent / 15);
}
if ($totalvotes <= "100" && $totalvotes => "51") {
$pollbar = ($pollbarpercent / 8);
}
if ($totalvotes <= "50" && $totalvotes => "11") {
$pollbar = ($pollbarpercent *2);
}
if ($totalvotes <= "10" && $totalvotes => "1" && $votes[$nums] => "1") {	
$pollbar = ($pollbarpercent *4);
}
}
else { $pollbar = 0; }
unless ($totalvotes eq 0) {
$pollpercent = ( $votes[$nums] * 100 / $totalvotes);
}
my($roundedpercent) = shift;
$pollpercent = int($pollpercent + .5);

    
    $yymain .= qq~&nbsp;&nbsp;<IMG SRC="$imagesdir/poll_left.gif"><IMG SRC="$imagesdir/poll_middle.gif" height="12" width="$pollbar"><IMG SRC="$imagesdir/poll_right.gif"> $votes[$nums] ($pollpercent%)</td>
  </tr>~;
  $nums++;
  }

	$yymain .= qq~</table>
	<br><b>$polltxt{'17'}: $totalvotes</b>&nbsp;&nbsp;&nbsp;$lockpoll<br><br>
    </td>
  </tr>
</table>
		</td>
		</tr>
		</table>~;
	}
	else {
		$board = $INFO{'board'};
		
		# Censor the question.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$pollquestion =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		$yymain.= qq~<table border="0" width="100%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
		<tr>
		<td height="22" valign="middle" class="titlebg" color="$color{'titlebg'}">
		<font size=2 class="text1" color="$color{'titletext'}">&nbsp;$img{'pollicon'}&nbsp;$polltxt{'15'}</font>
		</td>
		</tr>
		<tr>
		<td valign="top" align="middle" bgcolor="$color{'windowbg'}">
		<form name="poll" method="post" action="$cgi;action=vote;board=$board;num=$viewnum">
		<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr valign="top"> 
    <td width="65"><b>$polltxt{'16'}:</b></td>
    <td>$pollquestion<br><br>
    </td>
  </tr>
  <tr> 
    <td>&nbsp;</td>
        <td>
    <table width="90%" border="0" cellspacing="0" cellpadding="0">~;
    $nums = 0;
    pop (@options);
    foreach (@options) {
        	# Censor the options.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$options[$nums] =~ s~\Q$tmpa\E~$tmpb~gi;
		}	
		chop $options_uncensored[$nums];
    	$yymain .= qq~
  <tr valign="top"> 
	<td width="5%"><INPUT type="radio" name="option" value="$nums|$options_uncensored[$nums]"></td>
    <td width="95%" valign="middle"><b>$options[$nums]</b></td>
  </tr>~;
  $nums++;
  }
	$yymain .= qq~
	</td>
  </tr>
</table>
<table>
<tr>
		<td width="5%"><INPUT type="submit" value="$polltxt{'18'}"></td>
    <td width="95%"><b><a href="$cgi;action=display;num=$viewnum;viewresults=yes">$polltxt{'19'}</a></b>&nbsp;&nbsp;$lockpoll</td>
    </tr>
    </table>
    </form>
		</td>
		</tr>
		</table>
		</td>
		</tr>
		</table>~;	
	}
}
$yymain .= qq~
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg">
        <font size=2 class="text1" color="$color{'titletext'}">&nbsp;<img src="$imagesdir/$threadclass.gif" alt="">
        &nbsp;<b>$txt{'29'}</b></font></td>
        <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="80%">
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;

	# Load background color list.
	@bgcolors = ( $color{windowbg}, $color{windowbg2} );
	$bgcolornum = scalar @bgcolors;
	@cssvalues = ( "windowbg","windowbg2" );
	$cssnum = scalar @bgcolors;

	if(!$MenuType) { $sm = 1; }
	$counter = 0;

	fopen(FILE,"$datadir/$viewnum.txt") || &fatal_error("104 $txt{'106'}: $txt{'23'} $viewnum.txt");

	# Skip past the posts in this thread until we reach $start.
	while($counter < $start && ($buffer = <FILE>)) { $counter++; }

	$#messages = $maxmessagedisplay - 1;
	for($counter = 0; $counter < $maxmessagedisplay && ($buffer = <FILE>); $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(FILE);
	$#messages = $counter - 1;
	$counter = $start;

	# For each post in this thread:
	foreach (@messages) {
		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$css = $cssvalues[($counter % $cssnum)];
		chomp;
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb, $msf, $mfn) = split(/[\|]/, $_);
		# Should we show an attachment file?
			if( $msf && $mfn && $msf ne "" && $mfn ne "") {
			if (-e ("$upload_dir/$mfn")) {
			$attachment = qq~<font size="1"><a href="$msf" target="_blank"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle">  $mfn</a></font>~;
				if(($mfn =~ /(jpg|gif|bmp|png|jpeg)$/i) && ($amdisplaypics == 1)) {
					$showattach = qq~<hr width="100%"><center><img src="$msf" alt"$msf" border="0"></center>~;
				} else { 
					$showattach = ''; 
				}
			} else { 
				$attachment = qq~<font size="1"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle">  $mfn $fatxt{'1'}</font>~;
				$showattach = '';
			}
		} else {
			$attachment = '';
			$showattach = '';
		}
		
		# Should we show "last modified by?"
		if( $mlm && $showmodify && $mlm ne "" && $mlmb ne "") {
			$mlm = &timeformat($mlm);
			&LoadUser($mlmb);
			$mlmb = $userprofile{$mlmb}->[1] || $mlmb || $txt{'470'};
			$lastmodified = qq~&#171; <i>$txt{'211'}: $mlm $txt{'525'} $mlmb</i> &#187;~;
		}
		else {
			$mlm = '-';
			$lastmodified = '';
		}
		$msub ||= $txt{'24'};
		$messdate = &timeformat($mdate);
		if ($settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' && $allow_mod == 1) { $mip = $mip } else { $mip = "$txt{'511'}"; }
		$sendm = '';

		# If the user isn't a guest, load his/her info.
		if($musername ne 'Guest' && ! $yyUDLoaded{$musername} && -e("$memberdir/$musername.dat") ) {
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
		if($yyUDLoaded{$musername}) {
			@userprofile = @{$userprofile{$musername}};
			$displayname = $userprofile[1];
			$star = $memberstar{$musername};
			$memberinfo = $memberinfo{$musername};
			$memberinfo =~ s~\n~~g;
			$icqad = $icqad{$musername};
			$yimon = $yimon{$musername};
			if($username ne 'Guest') {
				# Allow instant message sending if current user is a member.
				$sendm = qq~$menusep<a href="$cgi;action=imsend;to=$useraccount{$musername}">$img{'message_sm'}</a>~;
			}
			$usernamelink = $link{$musername};
			$postinfo = qq~$txt{'26'}: $userprofile[6]<br>~;
			$memail = $userprofile[2];
		}
		else {
			$musername = "Guest";
			$star = '';
			$memberinfo = "$txt{'28'}";
			$icqad = '';
			$yimon = '';
			$usernamelink = qq~<font size="2"><b>$mname</b></font>~;
			if ($memberinfo eq "$txt{'28'}") { $usernamelink = qq~<font size="2"><b>$mname<br></b></font>~; }
			$postinfo = '';
			@userprofile = ();
			$displayname = $mname;
		}
		# Censor the subject and message.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		# Run UBBC interpreter on the message.
		$message = $postmessage; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		$profbutton = $profilebutton && $musername ne 'Guest' ? qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$img{'viewprofile_sm'}</a>$menusep~ : '';
		if($counter != 0) { $counterwords = "$txt{'146'} #$counter"; }
		else { $counterwords = ""; }
		# Print the post and user info for the poster.
		$yymain .= qq~
<a name="$counter"></a>
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$windowbg" class="$css">
        <table width='100%' cellpadding='4' cellspacing='0' class="$css" bgcolor="$windowbg">
          <tr>
            <td class="$css" bgcolor="$windowbg" valign="top" width="20%" rowspan="2"><font size="1">
            $usernamelink
            $memberinfo<BR>~;
	if($musername ne "Guest") {
		$yymain .= qq~
            $star<BR><BR>
            $userprofile[13]$userprofile[12]
            <BR>$userprofile[8] $icqad &nbsp; $userprofile[10] $yimon &nbsp; $userprofile[9]<BR>
~;
	}
	if($musername eq "Guest") {
		$yymain .= qq~
            <BR><a href="mailto:$memail">$img{'email_sm'}</a><BR><BR>
~;
	}
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $settings[7] eq "Global Moderator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<BR><BR>
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm<BR><BR>
~;
	}
&dispthem;
	$yymain .= qq~
            $userprofile[11]
            $postinfo
	    <br>$exp{$musername}
            </font></td>
            <td class="$css" bgcolor="$windowbg" valign="top" width="80%" height="100%">
            <table width='100%' border='0'>
              <tr>
                <td align="left" valign="middle"><img src="$imagesdir/$micon.gif" alt=""></td>
                <td align="left" valign="middle">
                <font size="2"><B>$msub</b></font> &nbsp;$attachment<BR>
		$out
                <font size="1">&#171; <B>$counterwords $txt{'30'}:</B> $messdate &#187;</font></td>
                <td align="right" valign="bottom" nowrap height="20">
                <font size=-1>
~;
if ($mstate != 1)
{
$yymain .= qq~
                <a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>
~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername || $settings[7] eq 'Global Moderator') {
		$yymain .= qq~  $menusep<a href="javascript:DoConfirm('$txt{'739'}','$cgi;action=modify2;thread=$viewnum;id=$counter;d=1')">$img{'delete'}</a>~;
	}
}
	$yymain .= qq~
                </font></td>
              </tr>
            </table>
            <hr width="100%" size="1" class="hr">
            <font size="2">
            $message
            </font>
            </td>
          </tr><tr>
            <td class="$css" bgcolor="$windowbg" valign="bottom">
            <table width="100%" border="0">
              <tr>
                <td align="left"><font size="1">$lastmodified</font></td>
                <td align="right"><font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font></td>
              </tr>
            </table>
            $showattach
            <font size="1">
            $userprofile[5]
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>~;
		$counter++;
	}
		if($settings[7] eq 'Administrator') {
$sadminf = qq(<b>$img{'admin_func'}</b> &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a><a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a><a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a><a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>);
}
	if(exists $moderators{$username} && $settings[7] ne 'Administrator' || $settings[7] eq 'Global Moderator') {
$sadminf = qq(<b>$img{'moderator_func'}</b> &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a><a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a><a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a><a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>);
}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
            <td class="catbg" bgcolor="$color{'catbg'}" align=right width="350"><font size=2>
            $replybutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
<table border="0" width="100%" cellpadding="0" cellspacing="0">~;
	  $yymain .= qq~
  <tr>
    <td align="left" valign="top" colspan="2">~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
		$yymain .= qq~<font size="1">$sadminf</font>~;
	}
	$yymain .= qq~
    </td>
    <td valign="top" height="18" align="right"><font size="1">$selecthtml</font></td>
  </tr><tr>
    <td colspan="3" valign="top" align="right"><font size="1">$nav</font></td>
  </tr>
</table>
~;
	$yytitle = $msubthread;
	&template;
	exit;
}
sub dispthem {

fopen(FILE, "<$datadir/$INFO{'num'}.sub");
	$thema4 = <FILE>;
	chomp $thema4;
	fclose(FILE);

fopen(FILE2, "<$boardsdir/$currentboard.sub");
$go2 = <FILE2>;
chomp $go2;
fclose(FILE2);

if ($thema4 ne "" && $go2 != 0 || $thema4 ne "" && $go2 eq "") {
$out = qq~<font size="1"><b>&#171;$esmtxt{'06'}: $thema4&#187;</b><br>~;}
else{$out = "";}

}

1;