###############################################################################
# Faq.pl                                                                      #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Project started by Zef Hemel (zef@zefnet.com)                   #
# Software Version: YaBB 1 Gold - Release                                     #
# =========================================================================== #
# Software Distributed by:    http://yabb.xnull.com                           #
# Support, News, Updates at:  http://yabb.xnull.com/community/                #
# =========================================================================== #
# Copyright (c) 2000-2001 X-Null - All Rights Reserved                        #
# Software by: The YaBB Development Team                                      #
###############################################################################

$recentplver="1 Gold - Release";

$useheader_footer = 1;	#if you use PHP or SSI,change to '0'
$backtotop = "back to top";
$backtoquestion = "back to questions page";

sub ShowFaq {
	$faqid = ($INFO{'id'}) ? $INFO{'id'} : 0;
	$faqtype = ($INFO{'type'}) ? $INFO{'type'} : 0;
        
	$currcat = &BoardCatGet($currentboard);
	$curboard = $currentboard;
      unless ( $currcat ) { &fatal_error("Cat not found"); }
	unless( &BoardAccessGet($currentboard) ) { &fatal_error( $txt{'1'} ); }

		chomp $curboard;
		fopen(FILE, "$boardsdir/$curboard.txt");
		@threads = <FILE>;
		fclose(FILE);

		for ($i = 0; $i < @threads; $i++) {
			chomp $threads[$i];
			($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
			fopen(FILE, "$datadir/$tnum.txt") || next;
			@messages2 = <FILE>;
			fclose(FILE);				

			$message = $messages2[0];
			chomp $message;
			if( $message ) {
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
				$mtime = stringtotime($mdate);
				$data{$mtime} = [$curboard, $tnum, $treplies, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns];
			}
		}


	@messages2 = sort {$b <=> $a } keys %data;

	print "Content-type: text/html\n\n";
        if($useheader_footer == 1){&FaqHeader;}
        
	if( @messages2 ) {
		$counter = 1;
		# Load Censor List
		&LoadCensorList;
	}
	else {
		print qq~<hr><b>No Entries available</b><hr>~;
	}
	if($faqid == 0){&FaqToc;}
        if($faqtype == 0){&FaqSeparator;}
        if($faqtype == 0){$loop = 0;&FaqAnswer;} elsif(($faqtype == 1) && ($faqid != 0)){$loop = $faqid-1;&FaqAnswer;}
        if($useheader_footer == 1){&FaqFooter;}
	exit;
}

# Output Header
sub FaqHeader {
	fopen(TEMPLATE,"faq_header.html") || die("$txt{'23'}: faq_header.html");
	@faq_header = <TEMPLATE>;
	fclose(TEMPLATE);
        
        $faqtitle = $boardname;
	for( $faq_headermain = 0; $faq_headermain < @faq_header; $faq_headermain++ ) {
		$faq_header_curline = $faq_header[$faq_headermain];
		$faq_header_curline =~ s~<yabb\s+(\w+)>~${"faq$1"}~g;
		print $faq_header_curline;
        }
}
        
# Output Separator
sub FaqSeparator {
                print "<hr>\n\n";
}

# Output TOC
sub FaqToc {
	for( $i = 0; $i < @messages2; $i++ ) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = @{ $data{$messages2[$i]} };

		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		if($enable_ubbc) { require "$sourcedir/YaBBC.pl"; &DoUBBC; }

		fopen(TEMPLATE,"faq_toc.html") || die("$txt{'23'}: faq_toc.html");
		@faq_toc = <TEMPLATE>;
		fclose(TEMPLATE);
                	
		$faqdate = &timeformat($mdate);
		$faqauthor = $tname;
		$faqanswer = $message;
		$faqicon = qq~<img src="$imagesdir/$micon.gif">~;
		$faqnumber = $i+1;
                if($faqtype == 0){
                	$faqquestion = qq~<a href="#id$faqnumber">$msub</a><br>~;
                }
                else{
                	$faqquestion = qq~<a href="$scripturl?board=$curboard&action=faq&type=1&id=$faqnumber">$msub</a><br>~;
                } 
		for( $faq_tocmain = 0; $faq_tocmain < @faq_toc; $faq_tocmain++ ) {
			$faq_toc_curline = $faq_toc[$faq_tocmain];
			$faq_toc_curline =~ s~<yabb\s+(\w+)>~${"faq$1"}~g;
			print $faq_toc_curline;
		}
        }
}

 # Output Answers
 sub FaqAnswer {
	for( $i = $loop; $i < @messages2; $i++ ) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = @{ $data{$messages2[$i]} };

		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		if($enable_ubbc) { require "$sourcedir/YaBBC.pl"; &DoUBBC; }
		fopen(TEMPLATE,"faq_answer.html") || die("$txt{'23'}: faq_answer.html");
		@faq_answer = <TEMPLATE>;
		fclose(TEMPLATE);
                	
		$faqdate = &timeformat($mdate);
		$faqauthor = $tname;
		$faqanswer = $message;
		$faqicon = qq~<img src="$imagesdir/$micon.gif">~;
		$faqnumber = $i+1;
                $faqquestion = qq~<a name=\"#id$faqnumber\"></a>$msub<BR>~; 
                if($faqid == 0){$faqback = qq~<A href="#top">$backtotop</A>~} else{$faqback = qq~<a href="javascript:history.go(-1)">$backtoquestion</a>~}
		for( $faq_answermain = 0; $faq_answermain < @faq_answer; $faq_answermain++ ) {
			$faq_answer_curline = $faq_answer[$faq_answermain];
			$faq_answer_curline =~ s~<yabb\s+(\w+)>~${"faq$1"}~g;
			print $faq_answer_curline;
		}
                if($faqtype == 1){last;};	#only 1 time
	}
}

# Output Footer
sub FaqFooter {
	fopen(TEMPLATE,"faq_footer.html") || die("$txt{'23'}: faq_footer.html");
	@faq_footer = <TEMPLATE>;
	fclose(TEMPLATE);
        print "$faq_footer";
	for( $faq_footermain = 0; $faq_footermain < @faq_footer; $faq_footermain++ ) {
		$faq_footer_curline = $faq_footer[$faq_footermain];
		print $faq_footer_curline;
        }
}

1;
