###############################################################################
# MessageIndex.pl                                                             #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$messageindexplver = "1 Gold - SP 1.1";

sub MessageIndex {
	my $start = int( $INFO{'start'} ) || 0;
	my( $bdescrip, $counter, $buffer, $pages, $showmods, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $dlp, $threadlength, $threaddate );
	my( @boardinfo, @threads );
	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	my $maxindex = $INFO{'view'} eq 'all' ? $threadcount : $maxdisplay;

	# Open and quickly read the current board thread list.
	# Skip past threads until we reach the "page" we want.
	fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt");
	@threadlist = <FILE>;
	@threadlist2 = '';
	fclose(FILE);

	# Get sort order and date mask
	$default_sort = "";
	$default_mask = "";
	if (-e "$boardsdir/$currentboard.opt" ) { require "$boardsdir/$currentboard.opt"; }
	my $sortmode = $INFO{'sort'} || $default_sort;
	my $datemask = $INFO{'date'} || $default_mask;
	if ($FORM{'sortmode'}) { $sortmode = $FORM{'sortmode'}; }
	if ($FORM{'datemask'}) { $datemask = $FORM{'datemask'}; }
	if ($sortmode eq "rating" && $enable_topicrating != 1) { $sortmode = "";}

	# Highlight current sort order and date mask
	my ( $sort1, $sort2, $sort3, $sort4, $sort5, $sort6, $sort7, $sort8 )= ();
	if ($sortmode eq "subject") { $sort2 = " selected" }
	elsif ($sortmode eq "created") { $sort3 = " selected" }
	elsif ($sortmode eq "author") { $sort4 = " selected" }
	elsif ($sortmode eq "last") { $sort5 = " selected" }
	elsif ($sortmode eq "replies") { $sort6 = " selected" }
	elsif ($sortmode eq "views") { $sort7 = " selected" }
	elsif ($sortmode eq "rating") { $sort8 = " selected" }
	elsif ($sortmode eq "none") { $sort1 = " selected" }
	else { $sort1 = " selected"; $sortmode = ""; }
	my ( $mask1, $mask2, $mask3, $mask4, $mask5, $mask6, $mask7 )= ();
	if ($datemask eq "today") { $mask1 = " selected" }
	elsif ($datemask eq "2") { $mask2 = " selected" }
	elsif ($datemask eq "5") { $mask3 = " selected" }
	elsif ($datemask eq "10") { $mask4 = " selected" }
	elsif ($datemask eq "20") { $mask5 = " selected" }
	elsif ($datemask eq "30") { $mask6 = " selected" }
	elsif ($datemask eq "all") { $mask7 = " selected" }
	else { $mask7 = " selected"; $datemask = "";  }

	# Mask Old Threads
	my @tmplist = ();
	if ( $datemask ne "" && $datemask ne "all") {
		$date2 = $date;
		if ($datemask == "today") {$days = "0";} else {$days = $datemask; }
		for($i=0;$i<$threadcount;$i++) {
			($dummy, $dummy, $dummy, $dummy, $date1, $dummy) = split( /\|/, $threadlist[$i], 6 );
			&calcdifference;
			if ($result <= $days) {$tmplist[++$#tmplist] = $threadlist[$i];}
		}
		@threadlist = @tmplist;
		$threadcount = $#threadlist + 1;
	}

	# Sort list
	if ($sortmode ne "" && $sortmode ne "none" && $threadcount > 0) {
		@tmplist = @threadlist;
		$date2 = $date;
		for($i=0;$i<$threadcount;$i++) {
			($mnum, $msub, $mname, $dummy, $mdate, $mreplies, $dummy) = split( /\|/, $threadlist[$i], 7 );
			if ($sortmode eq "subject") { $tmplist[$i] = $msub."|".$threadlist[$i];	}
			elsif ($sortmode eq "created") {
				fopen(FILE, "$datadir/$mnum.txt");
				$tmpa = <FILE>;
				fclose(FILE);
				($dummy, $dummy, $dummy, $date1, $dummy) = split(/\|/, $tmpa, 5);
				&calcdifference;
				$tmplist[$i] = $result."|".$threadlist[$i];
			}
			elsif ($sortmode eq "author") { $tmplist[$i] = $mname."|".$threadlist[$i]; }
			elsif ($sortmode eq "last") {
				$date1 = $mdate;
				&calcdifference;
				$tmplist[$i] = $result."|".$threadlist[$i];
			}
			elsif ($sortmode eq "replies") { $tmplist[$i] = $mreplies."|".$threadlist[$i]; }
			elsif ($sortmode eq "views") { 
				if( -e "$datadir/$mnum.data" ) {
					fopen(FILE, "$datadir/$mnum.data");
					$tmpa = <FILE>;
					fclose(FILE);
					($views, $dummy) = split(/\|/, $tmpa, 2);
					$views = $views ? $views - 1 : 0;
				} else { $views = "0"; }
				$tmplist[$i] = $views."|".$threadlist[$i]; 
			}
			elsif ($sortmode eq "rating") { 
				if( -e "$datadir/$mnum.data" ) {
					fopen(FILE, "$datadir/$mnum.data");
					$tmpa = <FILE>;
					fclose(FILE);
					($dummy, $dummy, $rate, $dummy) = split( /\|/, $tmpa, 4 );
					if ($rate eq "") { $rate = "0"; }
				} else { $rate = "0"; }
				$tmplist[$i] = $rate."|".$threadlist[$i]; 
			}
		}
		if ($sortmode eq "subject" || $sortmode eq "author") { @sortlist = sort{uc($a) cmp uc($b)} (@tmplist); }
		elsif ($sortmode eq "created" || $sortmode eq "last") { @sortlist = sort{$a<=>$b} (@tmplist); }
		else { @sortlist = sort{$b<=>$a} (@tmplist); }
		for($i=0;$i<$threadcount;$i++) {
			($dummy, $tmplist[$i]) = split(/\|/, $sortlist[$i], 2);
			$threadlist[$i] = $tmplist[$i]."\n";
		}
		chomp(@threadlist);
	}
	if ($sortmode eq "$default_sort") {$sortmode = "";}
	if ($sortmode ne "" ) {$sortmode = ";sort=".$sortmode;}
	if ($datemask eq "$default_mask") {$datemask = "";}
	if ($datemask ne "") {$datemask = ";date=".$datemask;}

	# Make sure the starting place makes sense.
	if( $start > $threadcount ) { $start = int( $threadcount % $maxindex ) * $maxindex; }
	elsif( $start < 0 ) { $start = 0; }

	# There are three kinds of lies: lies, damned lies, and statistics. 
	# - Mark Twain
	
	# Construct the page links for this board.
	$indexdisplaynum = 3;	# max number of pages to display
	$tmpa = 1;
	$tmpx = int( $threadcount / $maxindex );
	if ($start >= (($indexdisplaynum-1) * $maxindex)) { $startpage = $start - (($indexdisplaynum-1) * $maxindex); $tmpa = int( $startpage / $maxindex ) + 1; }
	if ($threadcount >= $start + ($indexdisplaynum * $maxindex)) { $endpage = $start + ($indexdisplaynum * $maxindex); } else { $endpage = $threadcount }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=messageindex;start=0$sortmode$datemask">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxindex) { $pageindex = qq~<a href="$cgi;action=messageindex;start=0$sortmode$datemask">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxindex ) {
		$pageindex .= $start == $counter ? qq~<B>$tmpa</B>&nbsp;~ : qq~<a href="$cgi;action=messageindex;start=$counter$sortmode$datemask">$tmpa</a>&nbsp;~;
		++$tmpa;
	}
	$tmpx = $threadcount - 1 - $maxindex;
	$outerpn = int($tmpx / $maxindex);
	$lastpn = int(($threadcount - 1) / $maxindex) + 1;
	$lastptn = ($lastpn - 1) * $maxindex;
	if ($endpage < $threadcount - $maxindex ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $threadcount) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=messageindex;start=$lastptn$sortmode$datemask">$lastpn</a>~;}
	$pageindex .= $pageindexadd;


	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$currcat = $cat;
	$cat = <FILE>;
	fclose(FILE);

	# Get the board's description
	fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.dat");
	@boardinfo = <FILE>;
	fclose(FILE);
	chomp @boardinfo;
	$bdescrip = $boardinfo[1];

	# Sticky Threads
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	$stickycount = $#stickys;
	fclose(FILE);
	for ($i=0; $i<=$threadcount; $i++) {
		($mnum) = split( /\|/, $threadlist[$i] );
		$l = 0;
		$is = 0;
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				$is = 1;
				$stickylist{$l} = $threadlist[$i];
				#splice(@threadlist,$i,1);
				last;
			}
			$l++;
		}
		if ($is == 0) { push(@threadlist2,$threadlist[$i]); }
	}
	if (!($threadlist2[0])) { shift(@threadlist2); }

	#now sort the stickys
	@stickylist2 = sort {$b <=> $a } keys %stickylist;
	for ($i=0; $i<=$stickycount; $i++) {
		chomp $stickylist{$i};
		if ($stickylist{$i}) { unshift(@threadlist2,"$stickylist{$i}\n"); }
	}

	$counter = 0;
	$tmpa = '';
	if($counter < $start && ($buffer = $threadlist2[$counter])) {
		$tmpa = $buffer;
		$counter++;
	}
	while($counter < $start && ($buffer = $threadlist2[$counter])) { $counter++; }

	$#threads = $maxindex - 1;
	$curln = $counter;
	$counter = 0;
	while( $counter < $maxindex && ( $buffer = $threadlist2[$curln+$counter] ) ) {
		chomp $buffer;
		$threads[$counter] = $buffer;
		$counter++;
	}
	$#threads = $counter - 1;

	# Let's get the info for the first thread in this forum.
	$tmpa ||= $threads[0];
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $tmpa );

	# Mark current board as seen.
	&dumplog($currentboard);

	# Build a list of the board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	# Load censor list.
	fopen(FILE,"$vardir/censor.txt");
	while( chomp( $buffer = <FILE> ) ) {
		($tmpa,$tmpb) = split(/=/,$buffer);
		push(@censored,[$tmpa,$tmpb]);
	}
	fclose(FILE);
# Begin addon for boardlinksSP1
	$blink = '';
	$i=0;
	$ii=0;
	while($LinkBoard[$i]) {
		if ($LinkBoard[$i] eq $currentboard){
			if ($ii == 0){
				$blink .= qq~<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
				$ii=1;
			} else {
				$blink .= qq~$blinkstxt{'13'}<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
			}
		}
		$i++;
	}
	if ($blink ne ''){
		$blink = qq~<table width="100%" cellpadding=3 cellspacing=0><TD align="center" class="catbg" bgcolor="$color{'titletext'}"><font size=2>$blinkstxt{'12'}$boardname</font><BR>$blink</TD></table><BR><BR>~;
	}
	if ($boardlinks != 1) {$yymain .= "$blink";}
# End addon for boardlinksSP1

	# Print the header and board info.
	$curboardurl = $curposlinks ? qq~<a href="$cgi" class="nav">$boardname</a>~ : $boardname;
	$yymain .= qq~
<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td><font size="2" class="nav"><b>
    <IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    <a href="$scripturl#$currcat" class="nav">$cat</a><br>
    <IMG SRC="$imagesdir/tline2.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    $curboardurl</b> <font size="1">$showmods</font></font></td>
  </tr>
</table>
~;
if($ShowBDescrip && $bdescrip ne "") {
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td width="100%"><font size="1">$bdescrip</font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
}
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size=-1>
~;
	if ($username ne 'Guest') {
if($showmarkread) {
	$yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~;
}
# --- Added for Notify Plus 2.2 --- #

# Notification on Board-level is enabled ?
if($enable_notification_board == 1) {
	$yymain .= qq~$menusep<a href="$cgi;action=notifyboard">$img{'notify'}</a>~;
}
# --- /Added for Notify Plus 2.2 --- #

}
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>
	    <a href="$cgi;action=createpoll;title=$polltxt{'2'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size=2>&nbsp;</font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="48%"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="14%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'109'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'110'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'301'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="27%"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
      </tr>
~;

	# Begin printing the message index for current board.
	if ($threadcount == 0) {
		$sortcolspan = 7;
		if ($enable_topicrating == 1) {++$sortcolspan;}
		if (($settings[7] eq 'Administrator' && $adminview != 0) || ($settings[7] eq 'Global Moderator' && $gmodview != 0) || (exists $moderators{$username} && $modview != 0)){++$sortcolspan;}
		$yymain .= qq~
      <tr>
        <td class="windowbg2" valign="middle" align="center" bgcolor="$color{'windowbg2'}" colspan="$sortcolspan"><br><font size=2><b>$sorttxt{'4'}</b></font><br><br></td>
      </tr>
		~;
	}
	$counter = $start;
	foreach( @threads ) {
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $_ );
# --- Added for Notify Plus 2.2 --- #

		# Reset Mark-image
		$markimg = "";

		# Is mark thread enabled and it's a Member ?
		if ($enable_mark_thread == 1 && $username ne 'Guest') {

			# Has the member a notification on this thread ?!
			if (fopen(FILE, "$datadir/$mnum.mail")) {

				# Read all records
				fopen(FILE, "$datadir/$mnum.mail");
				@mails = <FILE>;
				fclose(FILE);
				foreach $record (@mails) {

					chomp($record);
					($email, $format) = split(/\|/, $record);
					chomp($email);

					# Yep, Notification found
					if ($email eq $settings[2]) {
						$markimg  = qq~<img src='$imagesdir/mark_icon.gif' border='0'>~;
						last;
					}

				# End Foreach
				}

			# End if Has the member a notification
			}

		# End if Is mark thread enabled
		}

# --- /Added for Notify Plus 2.2 --- #

		# Set thread class depending on locked status and number of replies.
		$threadclass = 'thread';
		if( $mstate == 1 ) { $threadclass = 'locked'; }
		elsif( $mreplies > 24 ) { $threadclass = 'veryhotthread'; }
		elsif( $mreplies > 14 ) { $threadclass = 'hotthread'; }
		elsif( $mstate == 0 ) { $threadclass = 'thread'; }
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
				else { $threadclass = 'sticky'; }
			}
		}
        $pollthread = 0;
		if (-e "$datadir/$mnum.poll") { $pollthread = 1; }
		if (-e "$datadir/$mnum.polll") {$pollimg = qq~$img{'polliconclosed'}~;}
		else { $pollimg = qq~$img{'pollicon'}~; }
		$test = $mnum;
		&dispthem;

		# Decide if thread should have the "NEW" indicator next to it.
		# Do this by reading the user's log for last read time on thread,
		# and compare to the last post time on the thread.
		## LAST READ MOD ##
		$stuff = &getlog($mnum);
		($dlp, $lastread) = split( /\|/, $stuff );
		if ($lastread ne '') { $lastread = qq~;start=$lastread#$lastread~;}
		## /LAST READ MOD ##
		$threaddate = stringtotime($mdate);
		if( $max_log_days_old && $dlp != $threaddate && $username ne 'Guest' && &getlog("$currentboard--mark") < $threaddate ) {
			## LAST READ MOD ##
			$new = qq~<a href="$cgi;action=display;num=$mnum$lastread"><img src="$imagesdir/new.gif" border="0" alt="$txt{'302a'}"></a>~; 
			## /LAST READ MOD ##
		}
		else { $new = ''; }

		# Load the current nickname of the account name of the thread starter.
		if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
			&LoadUser($musername);
			$mname = $userprofile{$musername}->[1] || $mname || $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" alt="$txt{'27'}: $musername">$mname</a>~;
		}
		else {
			$mname ||= $txt{'470'};
		}

		# Censor the subject of the thread.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Decide how many pages the thread should have.
		$threadlength = $mreplies + 1;
		$pages = '';
		if( $threadlength > $maxmessagedisplay ) {
			$tmpa = 1;
			for( $tmpb = 0; $tmpb < $threadlength; $tmpb += $maxmessagedisplay ) {
				$pages .= qq~<a href="$cgi;action=display;num=$mnum;start=$tmpb">$tmpa</a>\n~;
				++$tmpa;
			}
			$pages =~ s/\n\Z//;
			$pages = qq~<BR><font size="1">&#171; $txt{'139'} $pages &#187;</font>~;
		}

		if( fopen(FILE, "$datadir/$mnum.data") ) {
			$tmpa = <FILE>;
			fclose(FILE);
		}
		elsif( -e "$datadir/$mnum.data" ) {
			&fatal_error("301 $txt{'106'}: $txt{'23'} $mnum.data");
		}
		else {
			$tmpa = '0';
		}


		($views, $lastposter) = split(/\|/, $tmpa);
		if( $lastposter =~ m~\AGuest-(.*)~ ) {
			$lastposter = $1;
		}
		else {
			unless( $lastposter eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			&LoadUser($lastposter);
		}
		$lastpostername = $lastposter || $txt{'470'};
		$views = $views ? $views - 1 : 0;

		# Print the thread info.
		$mydate = &timeformat($mdate);
		if ($pollthread eq 1) {
			 $yymain .= qq~
 <tr> 
    <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$threadclass.gif"></td>
    <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}" rowspan="2"><img src="$imagesdir/$micon.gif" alt="" border="0" align=middle></td>
    <td class="windowbg" valign="middle" width="48%" bgcolor="$color{'windowbg'}" rowspan="2"><font size=2>$new 
      <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
    <td class="windowbg2" valign="middle" align="center" width="14%" bgcolor="$color{'windowbg2'}" rowspan="2"><font size="1">$mname</font></td>
    <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}" rowspan="2"><font size=2>$mreplies</font></td>
    <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}" rowspan="2"><font size=2>$views</font></td>
    <td class="windowbg2" valign="middle" width="27%" bgcolor="$color{'windowbg2'}" rowspan="2"><font size="1">$mydate<br>
      $txt{'525'} $lastpostername</font></td>
  </tr>
  <tr>
    <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}">$pollimg</td>
  </tr>
  ~;
  }
		else {
		$yymain .= qq~
      <tr>
        <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$threadclass.gif"></td>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$micon.gif" alt="" border="0" align=middle></td>
<!--- Deleted for Notify Plus 2.2 --->
<!--- 	        <td class="windowbg" valign="middle" width="48%" bgcolor="$color{'windowbg'}"><font size=2>$new <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td> --->
<!--- /Deleted for Notify Plus 2.2 --->

<!--- Added for Notify Plus 2.2 --->
        <td class="windowbg" valign="middle" width="48%" bgcolor="$color{'windowbg'}"><font size=2>$new  $markimg <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
<!--- /Added for Notify Plus 2.2 --->

        <td class="windowbg2" valign="middle" align="center" width="14%" bgcolor="$color{'windowbg2'}"><font size="1">$mname</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size=2>$mreplies</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size=2>$views</font></td>
        <td class="windowbg2" valign="middle" width="27%" bgcolor="$color{'windowbg2'}"><font size="1">$mydate<br>$txt{'525'} $lastpostername</font></td>
      </tr>
~;
}
		++$counter;
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;
if ($enable_sortbar == 1) { $yymain .= qq~<form name="sortoptions" action="$cgi;action=messageindex;start=0" method="post" style="display: inline">~; }
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
	~;
	if ($enable_sortbar == 1) { 
	$yymain .= qq~
	    <td class="catbg" bgcolor="$color{'catbg'}" align="right"><font size="2"><nobr>
	    $sorttxt{'10'}: 
            <select name="sortmode" size=1>
              <option value="none"$sort1>$sorttxt{'18'}
              <option value="subject"$sort2>$sorttxt{'11'}
              <option value="created"$sort3>$sorttxt{'12'}
              <option value="author"$sort4>$sorttxt{'13'}
              <option value="last"$sort5>$sorttxt{'14'}
              <option value="replies"$sort6>$sorttxt{'15'}
              <option value="views"$sort7>$sorttxt{'16'}
              ~;
              if ($enable_topicrating == 1) {$yymain .= qq~<option value="rating"$sort8>$sorttxt{'17'}~;}
              $yymain .= qq~
            </select></nobr>
            <nobr>&nbsp; $sorttxt{'20'}: 
            <select name="datemask" size=1>
              <option value="today"$mask1>$sorttxt{'21'}
              <option value="2"$mask2>$sorttxt{'22'}
              <option value="5"$mask3>$sorttxt{'23'}
              <option value="10"$mask4>$sorttxt{'24'}
              <option value="20"$mask5>$sorttxt{'25'}
              <option value="30"$mask6>$sorttxt{'26'}
              <option value="all"$mask7>$sorttxt{'27'}
            </select>
            &nbsp; <input type="submit" value="$sorttxt{'30'}"></nobr></font></td>
	~;
	&jumpto;
	} else { 
	$yymain .= qq~
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size="2">
~;
	if ($username ne 'Guest') {
	if($showmarkread) { $yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~; }
# --- Added for Notify Plus 2.2 --- #

	# Notification on Board-level is enabled ?
	if($enable_notification_board == 1) {
		$yymain .= qq~$menusep<a href="$cgi;action=notifyboard">$img{'notify'}</a>~;
	}
# --- /Added for Notify Plus 2.2 --- #

}
	&jumpto;
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>
	    <a href="$cgi;action=createpoll;title=$polltxt{'2'}">$img{'createpoll'}</a>&nbsp;
	~;
	} 
	$yymain .= qq~
	  </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
~;
if ($enable_sortbar == 1) { $yymain .= qq~</form>~; }
$yymain .= qq~
<table cellpadding=0 cellspacing=0 width="100%">
  <tr>
	<td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/thread.gif"> $txt{'457'}<BR>
	<img src="$imagesdir/hotthread.gif"> $txt{'454'}<BR>
	<img src="$imagesdir/veryhotthread.gif"> $txt{'455'}
	</font></td><td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/locked.gif"> $txt{'456'}<BR>
	<img src="$imagesdir/sticky.gif"> $txt{'779'}<BR>
	<img src="$imagesdir/stickylock.gif"> $txt{'780'}
	</font></td>
	<td align="right" valign="middle"><font size="1">$selecthtml</font></td>
  </tr>
</table>
~;
	$yytitle = $boardname;
	if ($boardlinks == 1) {$yymain .= "$blink";}
	&template;
	exit;
}

sub MarkRead {
	# Mark all threads in this board as read.
	&dumplog("$currentboard--mark");
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}
sub dispthem {

fopen(FILE, "$datadir/$test.sub");
$thema5 = <FILE>;
chomp $thema5;
fclose(FILE);

fopen(FILE2, "$boardsdir/$currentboard.sub");
$go3 = <FILE2>;
chomp $go3;
fclose(FILE2);

if ($thema5 ne "" && $go3 != 0 || $thema5 ne "" && $go3 eq "") { $out = qq~[<i>$thema5</i>] ~; } else { $out = qq~~; }
}

1;